<template>
  <v-container
    style="height: 100%"
    fluid
  >
    <h2 class="font-weight-bold mb-3 sections--title">
      Accounting Settings
    </h2>

    <v-row>
      <v-col
        cols="12"
      >
        <v-card elevation="3">
          <v-card-title>
            Personal Details
          </v-card-title>

          <v-divider />

          <v-container fluid>
            <v-row dense>
              <v-col
                cols="12"
                sm="12"
                md="4"
              >
                <v-text-field
                  v-model="authUser.fname"
                  label="First Name"
                  outlined
                />
              </v-col>
              <v-col
                cols="12"
                sm="12"
                md="4"
              >
                <v-text-field
                  v-model="authUser.mname"
                  label="Second Name"
                  outlined
                />
              </v-col>
              <v-col
                cols="12"
                sm="12"
                md="4"
              >
                <v-text-field
                  v-model="authUser.lname"
                  label="Last Name"
                  outlined
                />
              </v-col>
              <v-col
                cols="12"
                sm="12"
                md="12"
              >
                <v-text-field
                  v-model="authUser.username"
                  label="Username"
                  outlined
                />
              </v-col>
              <v-col
                v-if="isChangePassword"
                cols="12"
                sm="12"
                md="6"
              >
                <v-text-field
                  v-model="authUser.password"
                  label="Password"
                  outlined
                  clearable
                  :type="showPassword ? 'text' : 'password'"
                  :append-icon="showPassword ? 'mdi-eye' : 'mdi-eye-off'"
                  @click:append="showPassword = !showPassword"
                />
              </v-col>
              <v-col
                v-if="isChangePassword"
                cols="12"
                sm="12"
                md="6"
              >
                <v-text-field
                  v-model="authUser.passwordConfirmation"
                  label="Password Confirmation"
                  outlined
                  clearable
                  :append-icon="showPasswordConfirmation ? 'mdi-eye' : 'mdi-eye-off'"
                  :type="showPasswordConfirmation ? 'text' : 'password'"
                  @click:append="showPasswordConfirmation = !showPasswordConfirmation"
                />
              </v-col>
            </v-row>
          </v-container>

          <v-card-actions>
            <v-spacer />
            <v-btn
              text
              :color="authUser.color"
              @click="isChangePassword = !isChangePassword"
            >
              Change Password
            </v-btn>

            <v-btn
              text
              @click="handleUpdateAccount"
            >
              Update
            </v-btn>
          </v-card-actions>
        </v-card>
      </v-col>
    </v-row>
  </v-container>
</template>

<script>
// eslint-disable-next-line no-unused-vars
import { mapActions, mapGetters, mapState } from 'vuex'

import _get from 'lodash/get'

export default {
  name: 'AdminSettings',

  data: () => ({
    dataStatus: {
      account: { loading: true }
    },

    showPassword: false,
    isChangePassword: false,
    showPasswordConfirmation: false
  }),

  computed: {
    ...mapState('users', {
      authUser: 'authUser'
    })
  },

  async created () {
    await this.bootstrap()
  },

  methods: {
    ...mapActions('users', {
      getAuthUser: 'getAuthUser',
      updateAuthenticatedAccount: 'updateAuthenticatedAccount'
    }),

    bootstrap () {
      const config = {
        loading: 'dataStatus.account.loading'
      }

      this.statusWrapper(async () => {
        await this.getAuthUser()
      }, config)
    },

    handleUpdateAccount () {
      const success = async () => {
        try {
          const dataClone = this.authUser

          delete dataClone.acronym

          await this.updateAuthenticatedAccount(dataClone)
          await this.bootstrap()

          this.showPassword = false
          this.isChangePassword = false
          this.showPasswordConfirmation = false

          this.$setAlert({ type: 'success' })
        } catch (error) {
          const message = _get(error, 'response.data.message')
          this.$setAlert({ type: 'error', text: message })
        }
      }

      this.$prompt({ success })
    }
  }
}
</script>
